"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseWriter = void 0;
var flat_1 = require("flat");
var ts_morph_1 = require("ts-morph");
var constants_1 = require("./constants");
var BaseWriter = /** @class */ (function () {
    function BaseWriter(options) {
        this.options = options;
        this.translationFnName = 't';
        this.translationFnTypeName = constants_1.IMPORTED_TRANSLATION_FN_TYPE_NAME;
        this.keySeparator = '.';
        this.innerInterpolationSeparator = ',';
        this.rootKey = '$value';
    }
    Object.defineProperty(BaseWriter.prototype, "interpolation", {
        get: function () {
            var _a, _b;
            return {
                prefix: (_a = this.options.interpolationPrefix) !== null && _a !== void 0 ? _a : '{{',
                suffix: (_b = this.options.interpolationSuffix) !== null && _b !== void 0 ? _b : '}}',
            };
        },
        enumerable: false,
        configurable: true
    });
    BaseWriter.prototype.write = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, moduleSpecifier, namedImport, source, objectStr;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.options.resultFile.addStatements([
                            '/* eslint-disable */',
                            '/* tslint:disable */',
                        ]);
                        if (this.options.translationFunctionTypeImport) {
                            _a = __read(this.options.translationFunctionTypeImport.split('#'), 2), moduleSpecifier = _a[0], namedImport = _a[1];
                            this.options.resultFile.addImportDeclaration({
                                kind: ts_morph_1.StructureKind.ImportDeclaration,
                                isTypeOnly: true,
                                namedImports: namedImport
                                    ? ["".concat(namedImport, " as ").concat(this.translationFnTypeName)]
                                    : [],
                                namespaceImport: !namedImport ? this.translationFnTypeName : undefined,
                                moduleSpecifier: moduleSpecifier,
                            });
                        }
                        return [4 /*yield*/, this.options.sourceFile];
                    case 1:
                        source = _b.sent();
                        objectStr = this.writeObjectAsStr(source);
                        this.options.resultFile.addFunction(this.buildLocaleKeysFn(objectStr));
                        this.options.resultFile.addTypeAlias({
                            kind: ts_morph_1.StructureKind.TypeAlias,
                            name: this.options.typeName,
                            type: "ReturnType<typeof ".concat(this.options.functionName, ">"),
                            isExported: true,
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    BaseWriter.prototype.buildLocaleKeysFn = function (objectStr) {
        var genericName = 'R';
        var generalFn = {
            kind: ts_morph_1.StructureKind.Function,
            name: this.options.functionName,
            isExported: true,
            typeParameters: this.options.translationFunctionTypeImport ||
                !this.options.translationFn
                ? []
                : [
                    {
                        name: genericName,
                        constraint: 'string',
                    },
                ],
            parameters: this.options.translationFn
                ? [
                    {
                        name: this.translationFnName,
                        type: this.options.translationFunctionTypeImport
                            ? this.translationFnTypeName
                            : "(...args: unknown[]) => ".concat(genericName),
                    },
                ]
                : [],
            statements: "return ".concat(objectStr, ";"),
        };
        return generalFn;
    };
    BaseWriter.prototype.writeObjectAsStr = function (flatValue, keyPrefix) {
        var _this = this;
        if (keyPrefix === void 0) { keyPrefix = ''; }
        var writer = this.options.project.createWriter();
        var flatKeys = Object.keys(flatValue);
        var objectToHandle = Object.fromEntries(Object.entries(flatValue).map(function (_a) {
            var _b = __read(_a, 2), key = _b[0], value = _b[1];
            var isParentKey = flatKeys.some(function (flatKey) { return key !== flatKey && flatKey.startsWith("".concat(key, ".")); });
            if (isParentKey) {
                return [[key, _this.rootKey].join(_this.keySeparator), value];
            }
            return [key, value];
        }));
        objectToHandle = this.options.flatten
            ? objectToHandle
            : (0, flat_1.unflatten)(objectToHandle);
        writer.inlineBlock(function () {
            Object.entries(objectToHandle).forEach(function (_a) {
                var _b = __read(_a, 2), key = _b[0], value = _b[1];
                var localeKey = key === _this.rootKey
                    ? keyPrefix
                    : [keyPrefix, key].filter(Boolean).join('.');
                var valueToSet;
                var comment = '';
                if (typeof value === 'string') {
                    valueToSet = _this.options.translationFn
                        ? _this.buildFunction(localeKey, value)
                        : "'".concat(localeKey, "'");
                    if (_this.options.showTranslations) {
                        comment = " /* ".concat(value, " */");
                    }
                }
                else {
                    valueToSet = _this.writeObjectAsStr(value, localeKey);
                }
                var keyToSet = /([^A-z0-9_$]|^[0-9])/.test(key) ? "'".concat(key, "'") : key;
                writer.writeLine("".concat(keyToSet, ": ").concat(valueToSet, ",").concat(comment));
            });
        });
        return writer.toString();
    };
    BaseWriter.prototype.buildFunction = function (key, value) {
        var interpolationKeys = this.getInterpolationKeys(value);
        var param = '';
        var secondCallParam = '';
        if (interpolationKeys.length) {
            param = "data: Record<".concat(interpolationKeys
                .map(function (k) { return "'".concat(k, "'"); })
                .join(' | '), ", unknown>");
            secondCallParam = ', data';
        }
        return "(".concat(param, ") => ").concat(this.translationFnName, "('").concat(key, "'").concat(secondCallParam, ")");
    };
    BaseWriter.prototype.getInterpolationKeys = function (value) {
        var _this = this;
        var _a;
        var _b = __read(value.split(this.interpolation.prefix)), first = _b[1], tail = _b.slice(2);
        var _c = __read((_a = first === null || first === void 0 ? void 0 : first.split(this.interpolation.suffix)) !== null && _a !== void 0 ? _a : [], 1), firstKey = _c[0];
        var extractInterpolationValue = function (str) {
            var _a = __read(str.split(_this.innerInterpolationSeparator), 1), result = _a[0];
            return result;
        };
        return tail
            .reduce(function (result, substr) {
            if (substr.includes(_this.interpolation.suffix)) {
                var _a = __read(substr.split(_this.interpolation.suffix), 1), nextKey = _a[0];
                result.push(extractInterpolationValue(nextKey));
            }
            return result;
        }, firstKey ? [extractInterpolationValue(firstKey)] : [])
            .filter(Boolean);
    };
    return BaseWriter;
}());
exports.BaseWriter = BaseWriter;
