"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Generator = void 0;
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var util_1 = __importDefault(require("util"));
var flat_1 = require("flat");
var ts_morph_1 = require("ts-morph");
var BaseWriter_1 = require("./BaseWriter");
var ReactWriter_1 = require("./ReactWriter");
var constants_1 = require("./constants");
var utils_1 = require("./utils");
var Generator = /** @class */ (function () {
    function Generator(options) {
        this.options = options;
        this.project = new ts_morph_1.Project({
            manipulationSettings: {
                indentationText: ts_morph_1.IndentationText.TwoSpaces,
                quoteKind: ts_morph_1.QuoteKind.Single,
            },
        });
        this.sourceFile = util_1.default
            .promisify(fs_1.default.readFile)(this.options.srcFile, 'utf-8')
            .then(function (json) { return JSON.parse(json); })
            .then(function (json) { return (0, flat_1.flatten)(json); });
    }
    Object.defineProperty(Generator.prototype, "functionName", {
        get: function () {
            var _a;
            return (_a = this.options.functionName) !== null && _a !== void 0 ? _a : constants_1.DEFAULT_FN_NAME;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Generator.prototype, "translateFn", {
        get: function () {
            var _a;
            return (_a = this.options.translationFn) !== null && _a !== void 0 ? _a : true;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Generator.prototype, "typeName", {
        get: function () {
            var name = constants_1.DEFAULT_TYPE_NAME;
            if (this.options.functionName) {
                name = "I".concat((0, utils_1.capitalize)(this.options.functionName));
            }
            return name;
        },
        enumerable: false,
        configurable: true
    });
    Generator.prototype.writeResultFile = function () {
        return __awaiter(this, void 0, void 0, function () {
            var resultFile;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        resultFile = this.project.createSourceFile(path_1.default.join(this.options.outDir, "".concat(this.functionName, ".").concat(this.options.reactBindings ? 'tsx' : 'ts')), '', {
                            overwrite: true,
                            scriptKind: this.options.reactBindings ? ts_morph_1.ScriptKind.TSX : ts_morph_1.ScriptKind.TS,
                        });
                        return [4 /*yield*/, new BaseWriter_1.BaseWriter(__assign(__assign({}, this.options), { project: this.project, sourceFile: this.sourceFile, functionName: this.functionName, translationFn: this.translateFn, typeName: this.typeName, resultFile: resultFile })).write()];
                    case 1:
                        _a.sent();
                        if (!this.options.reactBindings) return [3 /*break*/, 3];
                        return [4 /*yield*/, new ReactWriter_1.ReactWriter(__assign(__assign({}, this.options), { project: this.project, functionName: this.functionName, translationFn: this.translateFn, typeName: this.typeName, resultFile: resultFile })).write()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [2 /*return*/, resultFile];
                }
            });
        });
    };
    Generator.prototype.generate = function () {
        return __awaiter(this, void 0, void 0, function () {
            var resultFile;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.writeResultFile()];
                    case 1:
                        resultFile = _a.sent();
                        return [4 /*yield*/, resultFile.save()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Generator.prototype.generateAsText = function () {
        return __awaiter(this, void 0, void 0, function () {
            var resultFile;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.writeResultFile()];
                    case 1:
                        resultFile = _a.sent();
                        return [2 /*return*/, resultFile.getFullText()];
                }
            });
        });
    };
    return Generator;
}());
exports.Generator = Generator;
