#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var cosmiconfig_1 = require("cosmiconfig");
var yargs_1 = __importDefault(require("yargs"));
var helpers_1 = require("yargs/helpers");
var Generator_1 = require("./Generator");
var constants_1 = require("./constants");
var cliDefinition = (0, yargs_1.default)((0, helpers_1.hideBin)(process.argv)).command('codegen [source]', 'Generates a factory from the keys of a locale.json file', function (y) {
    return y
        .positional('source', {
        type: 'string',
        describe: 'Locale JSON file path',
    })
        .option('output', {
        type: 'string',
        alias: 'o',
        describe: 'Distribution directory for generated factory',
    })
        .option('nested', {
        type: 'boolean',
        describe: 'Should create nested object',
        alias: 'n',
        default: true,
    })
        .option('translate', {
        type: 'boolean',
        alias: 't',
        default: true,
        describe: 'Should add translate function. NOTE: will wrap value with function',
    })
        .option('showTranslations', {
        type: 'boolean',
        describe: "Add translations as function's comment",
        default: true,
    })
        .option('functionName', {
        type: 'string',
        alias: 'f',
        describe: 'Generated function name',
        default: constants_1.DEFAULT_FN_NAME,
    })
        .option('singleCurlyBraces', {
        type: 'boolean',
        describe: 'Read interpolation arguments using single curly instead of double',
    })
        .option('reactHook', {
        type: 'boolean',
        describe: 'Generate React bindings (Provider and hook)',
    });
});
void (function () { return __awaiter(void 0, void 0, void 0, function () {
    var config, _a, _b, output, _c, reactHook, _d, singleCurlyBraces, functionName, source, showTranslations, translate, nested, entries, promises;
    var _e, _f, _g;
    return __generator(this, function (_h) {
        switch (_h.label) {
            case 0: return [4 /*yield*/, (0, cosmiconfig_1.cosmiconfig)('typedlocalekeys', {
                    packageProp: 'typedLocaleKeys',
                }).search()];
            case 1:
                config = (_e = (_h.sent())) === null || _e === void 0 ? void 0 : _e.config;
                _a = cliDefinition.argv, _b = _a.output, output = _b === void 0 ? (_f = config === null || config === void 0 ? void 0 : config.primaryOutput) !== null && _f !== void 0 ? _f : constants_1.DEFAULT_OUTPUT : _b, _c = _a.reactHook, reactHook = _c === void 0 ? config === null || config === void 0 ? void 0 : config.reactHook : _c, _d = _a.singleCurlyBraces, singleCurlyBraces = _d === void 0 ? config === null || config === void 0 ? void 0 : config.singleCurlyBraces : _d, functionName = _a.functionName, source = _a.source, showTranslations = _a.showTranslations, translate = _a.translate, nested = _a.nested;
                entries = Object.entries((_g = config === null || config === void 0 ? void 0 : config.entries) !== null && _g !== void 0 ? _g : {});
                if (source) {
                    entries.push([functionName, { source: source, output: output }]);
                }
                promises = entries.map(function (_a) {
                    var _b = __read(_a, 2), key = _b[0], value = _b[1];
                    return new Generator_1.Generator({
                        srcFile: typeof value === 'string' ? value : value.source,
                        outDir: typeof value !== 'string' && value.output ? value.output : output,
                        reactBindings: reactHook,
                        interpolationPrefix: singleCurlyBraces ? '{' : '{{',
                        interpolationSuffix: singleCurlyBraces ? '}' : '}}',
                        showTranslations: showTranslations,
                        functionName: key,
                        translationFn: translate,
                        flatten: !nested,
                    }).generate();
                });
                return [4 /*yield*/, Promise.all(promises)];
            case 2:
                _h.sent();
                return [2 /*return*/];
        }
    });
}); })();
